// parse_data.cpp
// Written by Nick Jones
// Edited 5/3/19

#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

typedef unsigned int uint;

int main(int argc, char** argv) {
    unsigned int c;
    vector<uint> raw_data;
    vector<uint> data;
    int i = 0;
    string filename;

    // open raw data file
    filename = (argc > 1) ? string(argv[1]) : "NBII000.DAT";
    cout << filename << endl;
    fstream raw_file(filename, fstream::binary | fstream::in);

    // read everything in
    uint* ptr = &(raw_data[0]);
    while (!raw_file.eof()) {
	raw_file.read((char*)(&c), 4);
	raw_data.push_back(((c & 0xFF000000) >> 24) | ((c & 0x00FF0000) >> 8) | 
		((c & 0x0000FF00) << 8) | ((c & 0x000000FF) << 24));
	i++;
    }

    raw_file.close();

    // do bit shifting to recover data
    int j;
    uint* buf = &(raw_data[0]);
    for (j = 0; j < i*3.2-16; j+=16) {
	data.push_back(((*buf >> 24) & 0b11111111) | ((*buf >> 8) & 0b1100000000));
	data.push_back(((*buf >> 18) & 0b111111) | ((*buf >> 2) & 0b1111000000));
	data.push_back(((*buf >> 12) & 0b1111) | ((*buf << 4) & 0b1111110000));
	data.push_back(((*buf >> 6) & 0b11) | ((*(buf+1) >> 22) & 0b1111111100));
	data.push_back(((*(buf+1) >> 16) & 0b11111111) | ((*(buf+1)) & 0b1100000000));
	data.push_back(((*(buf+1) >> 10) & 0b111111) | ((*(buf+1) << 6) & 0b1111000000));
	data.push_back(((*(buf+1) >> 4) & 0b1111) | ((*(buf+2) >> 20) & 0b1111110000));
	data.push_back(((*(buf+2) >> 30) & 0b11) | ((*(buf+2) >> 14) & 0b1111111100));
	data.push_back(((*(buf+2) >> 8) & 0b11111111) | ((*(buf+2) << 8) & 0b1100000000));
	data.push_back(((*(buf+2) >> 2) & 0b111111) | ((*(buf+3) >> 18) & 0b1111000000));
	data.push_back(((*(buf+3) >> 28) & 0b1111) | ((*(buf+3) >> 12) & 0b1111110000));
	data.push_back(((*(buf+3) >> 22) & 0b11) | ((*(buf+3) >> 6) & 0b1111111100));
	data.push_back(((*(buf+3)) & 0b11111111) | ((*(buf+4) >> 16) & 0b1100000000));
	data.push_back(((*(buf+4) >> 26) & 0b111111) | ((*(buf+4) >> 10) & 0b1111000000));
	data.push_back(((*(buf+4) >> 20) & 0b1111) | ((*(buf+4) >> 4) & 0b1111110000));
	data.push_back(((*(buf+4) >> 14) & 0b11) | ((*(buf+4) << 2) & 0b1111111100));

	buf += 5;
    }

    // write recovered data to a csv file
    string end_filename = (argc > 2) ? (string("data") + argv[2] + string(".csv"))
	: "data.csv";
    fstream end_file(end_filename, fstream::out);
    for (i = 0; i < j; i++)
	end_file << data[i] << "," << endl;

    end_file.close();

    return 0;
}
