/* hawkless_ear.h
 * Nick Jones
 * Created 4/5/19
 * Modified 4/5/19 */

#ifndef HAWKLESS_EAR_H
#define HAWKLESS_EAR_H

#include <xc.h>
#include <sys/attribs.h>
//#include "configbits-16ex8.h"
#include "ff.h"

// declare global variables
#define TIMER1_VEC_NUMBER 4
#define TIMER2_VEC_NUMBER 8
#define TIMER3_VEC_NUMBER 12
#define CN_VEC_NUMBER 26
#define ADC_VEC_NUMBER 27

#define SD_PORT _RG9
#define ESP_PORT _RD10
#define REC_BUTTON_PORT _RC9

#define SD_WRITE_SIZE 16000

#define DEFAULT_GAIN_DB 40

#define SAMPLING_PR 210

#define TRUE 1
#define FALSE 0

typedef unsigned char byte;
typedef unsigned int uint32;

/* Device Modes: controls allowed activity
   (e.g. no downloading during recording) */
enum DeviceModes {
    NO_MODE = -1,
    MODE_AWAKE,
    MODE_RECORD,
    MODE_DOWNLOAD,
    MODE_ERROR
} deviceMode;

enum ServerStatus {
    NO_STATUS = 0x10,
    START_REC = 0x11,
    STOP_REC = 0x12,
    CHANGE_GAIN = 0x13,
    DOWNLOAD = 0x14
};

void initGPIO();
void initTimers();
void initInterrupts();
void initSPI();
void initDAC();
void initSDCard();
void uninitSDCard();
void initADC();

byte ESPWrite(byte data);
int changeGain(byte dbGain);

int startRecording();
FRESULT createSDFile(FIL* data_file);

// global variables
byte* pADCBuffer;
byte ADCBuffer1[SD_WRITE_SIZE];
byte ADCBuffer2[SD_WRITE_SIZE];
int ADCBufferCounter;

FATFS Fatfs;
int sdWaiting;

#endif // HAWKLESS_EAR_H