/* sd_interface.c 
 * Nick Jones
 * Created 4/5/19
 * Modified 4/5/19 */

#include "bat_news_travels_fast.h"
#include "ff.h"

void initSDCard() {
    //Initialize Disk
    disk_initialize(0);

    //Mount File system
    f_mount(0, &Fatfs);
}

/* uninitSDCard */
void uninitSDCard() {
    //unmount file system
    f_mount(0,NULL);   
}

/* createSDFile */
FRESULT createSDFile(FIL* data_file) {
    // Open/create Fileset.dex
    FRESULT fopen_res;
    BYTE access_mode;
    BYTE access_mode2;
    
    char master_file_name[] = "Fileset.dex";
    char file_name[] = "NBII000.dat";
    
    access_mode2 = (FA_CREATE_ALWAYS | FA_OPEN_ALWAYS | FA_CREATE_NEW | FA_WRITE |FA_READ);
    access_mode = (FA_OPEN_ALWAYS | FA_WRITE |FA_READ);
    
    FIL master_file;
    fopen_res = f_open(&master_file, master_file_name, (BYTE)access_mode);

    // Read 1 byte from file
    char buff = 0;
    unsigned int numread = 0;

    // if it opened (it exists), continue, otherwise create it
    if(fopen_res == FR_OK)
        fopen_res = f_read(&master_file, &buff, 1, &numread);
    else {
        f_close(&master_file);
        fopen_res = f_open(&master_file, master_file_name, (BYTE)access_mode2);
        numread = 0 ;
    }

    // if nothing was read (empty master file), write 0
    if (numread == 0) {
        buff=0;
        fopen_res=f_write(&master_file, &buff, 1, &numread);
    }
    // otherwise increment by 1 and overwrite (why are we closing/opening?)
    else {
        f_close(&master_file);
        f_open(&master_file, master_file_name, (BYTE)access_mode);
        buff++;
        fopen_res = f_write(&master_file, &buff, 1, &numread);
    }

    //close master file
    f_close(&master_file);

    //Determine name of new file to create based on index number
    if (buff <= 9)
        file_name[6] = buff + 48;
    else if (buff <= 99) {
        file_name[5] = (buff / 10) + 48;
        file_name[6] = (buff % 10) + 48;
    }
    
    return f_open(data_file, file_name, (BYTE)access_mode2);
}